<template>

    <vue-bootstrap-typeahead ref="autocompleteInput"
                             v-model="searchTerm"
                             size="lg"
                             :inputClass="styles"
                             placeholder="Start typing..."
                             :data="autocompleteList"
                             :serializer="s => s.text"
                             :minMatchingChars="1"
                             @hit="selectedItem = $event">
    </vue-bootstrap-typeahead>

</template>

<script>

    import VueBootstrapTypeahead from 'vue-bootstrap-typeahead';

    export default {

        mounted() {

            this.disableInput();
        },

        data() {

            return {

                searchTerm: '',
                autocompleteList: [],
                selectedItem: null,
                typingTimeout: null
            }
        },

        components: { VueBootstrapTypeahead },

        props: {

            /**
             * Name of the entity used for autocomplete api call.
             */
            entity: { type: String },

            disabled: { type: Boolean, default: () => false },

            additionalQueryParams: { type: Object, default: () => {} },

            defaultText: { type: String, default: () => '' },

            styles: { type: String, default: () => { return 'form-control m-input'}}
        },

        methods: {

            /**
             * Get results for given query string.
             *
             * @param query
             */
            search(query) {

                this.setEntityLoadingStatus('autocompleteList', true);

                axios.get(route('admin.' + this.entity + '.autocomplete', Object.assign({ query: query }, this.additionalQueryParams)))

                    .then( (response) => this.autocompleteList = response.data.data)

                    .catch( (errors) => parseResponseErrors(errors.response, this))

                    .then( () => this.setEntityLoadingStatus('autocompleteList', false))
            },

            /**
             * Disable input in autocomplete
             */
            disableInput() {

                this.$refs.autocompleteInput.$refs.input.disabled = this.disabled;
            }
        },

        computed: {

            /**
             * Check autoload status.
             */
            autocompleteLoading() {

                return this.$store.state.loading.autocompleteList;
            }
        },

        watch: {

            /**
             * Get new search results after typing is finished.
             *
             * @param newSearchTerm
             */
            searchTerm(newSearchTerm) {

                clearTimeout(this.typingTimeout);

                if (newSearchTerm !== '') {

                // Prevent double api call
                    if (this.selectedItem !== null) {

                        if (this.selectedItem.text == newSearchTerm) {

                            return;
                        }
                    }
                //

                    this.typingTimeout = setTimeout(() => {

                        this.search(newSearchTerm);

                        clearTimeout(this.typingTimeout);

                    }, 300);

                } else {

                    this.autocompleteList = [];
                }
            },


            /**
             * Fire event when selected item is changed.
             *
             * @param newSelectedItem
             */
            selectedItem(newSelectedItem) {

                this.$emit('itemSelected', newSelectedItem);
            },


            /**
             * Disable input.
             */
            disabled() {

                this.disableInput();
            },


            /**
             * If prop is changed update component.
             *
             * @param newDefaultText
             */
            defaultText(newDefaultText) {

                this.$refs.autocompleteInput.inputValue = newDefaultText
            }
        }
    };
</script>